﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Mvc_entityFramework.Models;
using Infragistics.Web.Mvc;
using System.Collections;

namespace Mvc_entityFramework.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            return View();
        }

        [GridDataSourceAction]
        public ActionResult CustomerList()
        {
            return View(CustomerModel.GetCustomerList());
        }

        public ActionResult UpdateCustomer(string ig_transactions)
        {
            ArrayList transactions = (ArrayList)Procurios.Public.JSON.JsonDecode(ig_transactions);
            
            var ctx = new NORTHWINDEntities();
            var ds = ctx.Customers;

            ViewData["GenerateCompactJSONResponce"] = false;

            GridModel m = new GridModel();

            foreach (Hashtable t in transactions)
            {
                switch (t["type"].ToString())
                {
                    case "row":

                        string x = t["rowId"].ToString();

                        var customer=(from p in ctx.Customers where p.CustomerID==x select p).Single();

                        var row=(Hashtable)t["row"];
                        if(row["CompanyName"] !=null)
                        {
                            customer.CompanyName=row["CompanyName"].ToString();
                        }
                          if(row["ContactTitle"] !=null)
                        {
                            customer.CompanyName=row["ContactTitle"].ToString();
                        }
                         if(row["ContactName"] !=null)
                        {
                            customer.CompanyName=row["ContactName"].ToString();
                        }
                        if(row["Country"] !=null)
                        {
                            customer.CompanyName=row["Country"].ToString();
                        }

                        break;

                    case "newrow":

                        var newrow=(Hashtable)t["row"];

                        var newCustomer=new Customer
                        {
                            CustomerID=newrow["CustomerID"].ToString(),
                             CompanyName=newrow["CompanyName"].ToString(),
                             ContactTitle=newrow["ContactTitle"].ToString(),
                             ContactName=newrow["ContactName"].ToString(),
                             Country=newrow["Country"].ToString(),
                        };

                        ctx.Customers.AddObject(newCustomer);
                        break;

                    case "deleterow":
                        string id=t["rowId"].ToString();
                        var deleteCustomer = (from p in ctx.Customers where p.CustomerID == id select p).FirstOrDefault();
                        if(deleteCustomer !=null)
                        {
                            ctx.Customers.DeleteObject(deleteCustomer);
                        }
                        break;
                }
            }
            ctx.SaveChanges();
            return RedirectToAction("Index");

        }
    }
}
